<?php

/*
Plugin Name: IMDb Easy Movie Embed (IEME)
Plugin URI: http://www.cinemarx.ro/
Description: Inserts short movie info (actors, directors, short review, runtime) in your posts. Uses http://www.imdb.com/ for serving data. (example: [http://www.imdb.com/title/tt0068646/])
Version: 0.1.2.1
Author: szz
Author URI: http://www.cinemarx.ro/
License: GPL
*/


define('L_IEME_VERSION', '0.1.2.1');
define('L_IEME_OPTIONS_TITLE', 'IMDb Easy Movie Embed Options');
define('L_IEME_WIDTH', 'Width:');
define('L_IEME_HEIGHT', 'Height:');
define('L_IEME_THEME', 'Theme/Style:');
define('L_IEME_BACKGROUND', 'Background color:');
define('L_IEME_FONT_FAMILY', 'Default font family:');
define('L_IEME_FONT_SIZE', 'Default font size:');
define('L_IEME_DESCRIPTION_LENGTH', 'Plot description length:');
define('L_IEME_LANGUAGE', 'Language:');
define('L_IEME_SOURCE', 'Source:');
define('L_IEME_UPDATE_BTN', 'Update options &raquo;');
define('L_IEME_RESETCACHE_BTN', 'Clear cache &raquo;');
define('L_IEME_MESSAGE_OPTIONS_UPDATED', 'Options updated.');
define('L_IEME_MESSAGE_CACHE_CLEARED', 'Cache cleared.');
define('L_IEME_INFO', 'For further instructions: <a target="_blank" href="mailto:office@cinemarx.ro">office@cinemarx.ro</a>');
global $table_prefix;
define('CINEMARX_IEME_TABLE', $table_prefix . 'cinemarx_ieme');
define('CINEMARX_IEME_CACHE_HREF', 'http://www.cinemarx.ro/filme/embed/?rx_co&');
define('CINEMARX_IEME_CACHE_EXPIRE_TIME', 60*24*60*60/* 60 days */);

function wp_ieme_install() {
	global $table_prefix, $wpdb, $user_level;

	# usually: wp_movie_ratings
	$table_name = CINEMARX_IEME_TABLE;

	# only special users can install plugins
	if ($user_level < 8) { return; }

	# create movie ratings table
	if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {

		$sql = "CREATE TABLE " . $table_name . " (
			cache_id char(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL default '',
      cache_content text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
			cache_time int(11) unsigned NOT NULL default '0',
			PRIMARY KEY (cache_id)
		);";

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);
	}
  // enable (uncomment) the following block if you have encoding problems (question marks)
  // disable & enable the plugin from plugin admin area
  /*
  else
	{
    $sql = "ALTER TABLE " . $table_name . " CHANGE `cache_content` `cache_content` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
    $wpdb->query($sql);
  }
  */


  update_option('ieme_rx_width', '500px');
  update_option('ieme_rx_height', '180px');
  update_option('ieme_rx_theme', 'simple');
  update_option('ieme_rx_background', 'FFFFFF');
  update_option('ieme_rx_fontfamily', 'Arial,Verdana,Tahoma,sans-serif');
  update_option('ieme_rx_fontsize', '13px');
  update_option('ieme_rx_description_length', '200');
  update_option('ieme_rx_language', 'english');
  update_option('ieme_rx_source', 'IMDb');

  activate_ieme_options();

}
# Hook for plugin installation
add_action('activate_' . dirname(plugin_basename(__FILE__)) . '/' . basename(plugin_basename(__FILE__)), 'wp_ieme_install');


// bloggers do not deactivate plugins before update, so:
function activate_ieme_options()
{
  if ('16' != get_option('ieme_options_activated'))
  {
    $default_options = array(
      'simple' => array(
        'width' => '500px',
        'height' => '180px',
        'background' => 'FFFFFF',
        'fontfamily' => 'Arial,Verdana,Tahoma,sans-serif',
        'fontsize' => '13px',
        'description' => '200',
      ),
      'advanced' => array(
        'width' => '500px',
        'height' => '180px',
        'background' => 'FFFFFF',
        'fontfamily' => 'Arial,Verdana,Tahoma,sans-serif',
        'fontsize' => '13px',
        'description' => '0',
      ),
      'advanced-description' => array(
        'width' => '500px',
        'height' => '180px',
        'background' => 'FFFFFF',
        'fontfamily' => 'Arial,Verdana,Tahoma,sans-serif',
        'fontsize' => '13px',
        'description' => '200',
      ),
      'vertical' => array(
        'width' => '180px',
        'height' => '500px',
        'background' => 'FFFFFF',
        'fontfamily' => 'Arial,Verdana,Tahoma,sans-serif',
        'fontsize' => '12px',
        'description' => '0',
      ),
      'mini' => array(
        'width' => '500px',
        'height' => '100px',
        'background' => 'FFFFFF',
        'fontfamily' => 'Arial,Verdana,Tahoma,sans-serif',
        'fontsize' => '11px',
        'description' => '0',
      ),
    );


    $ieme_rx_theme = stripslashes(get_option('ieme_rx_theme'));

    $ieme_rx_width = stripslashes(get_option('ieme_rx_width'));
    $ieme_rx_height = stripslashes(get_option('ieme_rx_height'));
    $ieme_rx_background = stripslashes(get_option('ieme_rx_background'));
    $ieme_rx_fontfamily = stripslashes(get_option('ieme_rx_fontfamily'));
    $ieme_rx_fontsize = stripslashes(get_option('ieme_rx_fontsize'));
    $ieme_rx_description_length = stripslashes(get_option('ieme_rx_description_length'));

    foreach($default_options as $theme => $options)
    {
      // selected theme?
      if ($theme == $ieme_rx_theme)
      {
        update_option('ieme_rx_width[' . $theme . ']', $ieme_rx_width);
        update_option('ieme_rx_height[' . $theme . ']', $ieme_rx_height);
        update_option('ieme_rx_background[' . $theme . ']', $ieme_rx_background);
        update_option('ieme_rx_fontfamily[' . $theme . ']', $ieme_rx_fontfamily);
        update_option('ieme_rx_fontsize[' . $theme . ']', $ieme_rx_fontsize);
        update_option('ieme_rx_description_length[' . $theme . ']', $ieme_rx_description_length);
      }
      else
      {
        update_option('ieme_rx_width[' . $theme . ']', $options['width']);
        update_option('ieme_rx_height[' . $theme . ']', $options['height']);
        update_option('ieme_rx_background[' . $theme . ']', $options['background']);
        update_option('ieme_rx_fontfamily[' . $theme . ']', $options['fontfamily']);
        update_option('ieme_rx_fontsize[' . $theme . ']', $options['fontsize']);
        update_option('ieme_rx_description_length[' . $theme . ']', $options['description']);
      }
    }
    update_option('ieme_options_activated', '16');
  }
}

#wp_head

function wp_ieme_wp_head()
{
  if (isset($_REQUEST['rxreset']))
  {
    // do it only once
    global $wpdb;
    $wpdb->query("TRUNCATE TABLE " . CINEMARX_IEME_TABLE);
  }

  print '<link href="' . get_bloginfo('wpurl') . '/wp-content/plugins/imdb-easy-movie-embed-ieme/style.css?' . L_IEME_VERSION . '" rel="stylesheet" type="text/css" media="screen" /><!-- imdb-easy-movie-embed-ieme: v' . L_IEME_VERSION . ' -->';
}

// misc function(s)
function wp_cinemarx_cut($string, $length)
{
  // ...not perfect, but enough
  if (strlen($string) <= $length)
  {
    return $string;
  }

  return substr($string, 0, $length-3) . '...';
}


# main
function wp_ieme($string) {


  global $wpdb;

  activate_ieme_options();

  // theme
  $ieme_rx_theme = stripslashes(get_option('ieme_rx_theme'));
  // theme dependent settings
  $ieme_rx_width = stripslashes(get_option('ieme_rx_width[' . $ieme_rx_theme . ']'));
  $ieme_rx_height = stripslashes(get_option('ieme_rx_height[' . $ieme_rx_theme . ']'));
  $ieme_rx_background = stripslashes(get_option('ieme_rx_background[' . $ieme_rx_theme . ']'));
  $ieme_rx_fontfamily = stripslashes(get_option('ieme_rx_fontfamily[' . $ieme_rx_theme . ']'));
  $ieme_rx_fontsize = stripslashes(get_option('ieme_rx_fontsize[' . $ieme_rx_theme . ']'));
  $ieme_rx_description_length = stripslashes(get_option('ieme_rx_description_length[' . $ieme_rx_theme . ']'));
  // theme independent settings
  $ieme_rx_language = stripslashes(get_option('ieme_rx_language'));
  $ieme_rx_source = stripslashes(get_option('ieme_rx_source'));

  $search_for_patterns = array(
    '/\[http:\/\/.*?imdb.*?\/title\/(tt.*?)\/\]/i',
  );

  while (preg_match($search_for_patterns[0], $string, $matched))
  {
    $cache_data = NULL;
    $rx_data = NULL;

    $rx_url = 'rx_id=' . $matched[1] . '&rx_theme=' . $ieme_rx_theme . '&rx_width=' . $ieme_rx_width . '&rx_height=' . $ieme_rx_height . '&rx_background=' . $ieme_rx_background . '&rx_fontfamily=' . $ieme_rx_fontfamily . '&rx_fontsize=' . $ieme_rx_fontsize . '&rx_description_length=' . $ieme_rx_description_length . '&rx_language=' . $ieme_rx_language . '&rx_source=' . $ieme_rx_source;

    $sql = "SELECT cache_content, cache_time FROM " . CINEMARX_IEME_TABLE . " WHERE cache_id='" . md5($rx_url) . "' LIMIT 1";

    if (!($cache_data = $wpdb->get_row($sql, ARRAY_A)) || (time() > $cache_data['cache_time'] + CINEMARX_IEME_CACHE_EXPIRE_TIME))
    {
      $blog_url = get_option("siteurl");
      if ($rx_data = @file_get_contents(CINEMARX_IEME_CACHE_HREF . $rx_url . '&rx_referrer=' . $blog_url))
      {
        // alter read content (possibly distribute operations over client blogs)
        switch (strtolower($ieme_rx_source))
        {
          case 'imdb':
            // search for IMDb movie link
            // HELP: optimize regexp here
            if (FALSE !== preg_match('/href="(.*?imdb\.com.*?)"/i', $rx_data, $imdb_matched))
            {
              if ($imdb_data = @file_get_contents($imdb_matched[1]/*IMDb address of movie*/))
              {
                if (FALSE !== preg_match('/<h5>Plot:<\/h5>.*?<p>(.*?)</is', $imdb_data, $imdb_matched))
                {
                  $rx_data = preg_replace('/<p id="rxdescription">.*?<\/p>/is', '<p id="rxdescription">' . wp_cinemarx_cut(strip_tags(trim($imdb_matched[1])), $ieme_rx_description_length) . '</p>', $rx_data);
                }
              }
            }
            break;
        }
        if ($cache_data)
        {
          $sql = "UPDATE " . CINEMARX_IEME_TABLE . " SET `cache_content`='" . $wpdb->escape($rx_data) . "', `cache_time`=" . time() . " WHERE `cache_id`='" . $wpdb->escape(md5($rx_url)) . "' LIMIT 1";
          $wpdb->query($sql);
        }
        else
        {
          $sql = "INSERT INTO " . CINEMARX_IEME_TABLE . " (`cache_id`,`cache_content`,`cache_time`) VALUES ('" . $wpdb->escape(md5($rx_url)) . "', '" . $wpdb->escape($rx_data) . "', " . time() . ")";
          $wpdb->query($sql);
        }
        $cache_data = $rx_data;
      }
    }
    else
    {
      $cache_data = $cache_data['cache_content'];
    }

    if (NULL == $cache_data)
    {
      $replace_with_patterns = array(
        '<script type="text/javascript" src="http://www.cinemarx.ro/filme/embed/rxm.js"></script><script type="text/javascript">
          // <!--
          rx_id="' . $matched[1] . '";
    			rx_theme="' . $ieme_rx_theme . '";
    			rx_width="' . $ieme_rx_width . '";
    			rx_height="' . $ieme_rx_height . '";
    			rx_background="' . $ieme_rx_background . '";
    			rx_fontfamily="' . $ieme_rx_fontfamily . '";
    			rx_fontsize="' . $ieme_rx_fontsize . '";
    			rx_description_length="' . $ieme_rx_description_length . '";
    			rx_language="' . $ieme_rx_language . '";
    			rx_source="' . $ieme_rx_source . '";
    			rx_stylesheet_uri="' . get_bloginfo('wpurl') . '/wp-content/plugins/imdb-easy-movie-embed-ieme/style.css?' . L_IEME_VERSION . '";
    			rx_blog_stylesheet_uri="' . get_stylesheet_uri() . '";
    			rx_display();
    			// -->
    		</script>',
      );
    }
    else
    {
      $replace_with_patterns = array(
        $cache_data,
      );
    }

    foreach($search_for_patterns as $index => $pattern) {
        $string = str_replace($matched[0], $replace_with_patterns[$index], $string);
    }

  }


  return $string;
}
function wp_ieme_rss($string) {

  $search_for_patterns = array(
    '/\[rxmovie-(.*?)(-(.*?))?\]/i',
  );
  $replace_with_patterns = array(
    '',
  );

  foreach($search_for_patterns as $index => $pattern) {
      $string = preg_replace($pattern, $replace_with_patterns[$index], $string);
  }

  return $string;
}

add_filter('the_content', 'wp_ieme', 9/*smaller than default priority 10 - in case of combination with a lightbox plugin*/);
add_filter('the_content_rss', 'wp_ieme_rss', 8/*smaller than default priority 10 - in case of combination with a lightbox plugin*/);




# ADMIN

function wp_ieme_options_page()
{
  activate_ieme_options();

  if (isset($_POST['rx_submit']))
  {
    // theme modified?
    $ieme_rx_theme = get_option('ieme_rx_theme');
    if ($ieme_rx_theme != $_POST['rx_theme'])
    {
      update_option('ieme_rx_theme', $_POST['rx_theme']);
    }
    else
    {
      // theme dependent settings
      update_option('ieme_rx_width[' . $ieme_rx_theme . ']', $_POST['rx_width']);
      update_option('ieme_rx_height[' . $ieme_rx_theme . ']', $_POST['rx_height']);
      update_option('ieme_rx_background[' . $ieme_rx_theme . ']', $_POST['rx_background']);
      update_option('ieme_rx_fontfamily[' . $ieme_rx_theme . ']', $_POST['rx_fontfamily']);
      update_option('ieme_rx_fontsize[' . $ieme_rx_theme . ']', $_POST['rx_fontsize']);
      update_option('ieme_rx_description_length[' . $ieme_rx_theme . ']', $_POST['rx_description_length']);
    }
    // theme independent settings
    //update_option('ieme_rx_language', $_POST['rx_language']);
    //update_option('ieme_rx_source', $_POST['rx_source']);

    print '<div id="message" class="updated fade"><p>' . L_IEME_MESSAGE_OPTIONS_UPDATED . '</p></div>';
  }
  
  if (isset($_POST['rx_resetcache']))
  {
    global $wpdb;
    $wpdb->query("TRUNCATE TABLE " . CINEMARX_IEME_TABLE);
    print '<div id="message" class="updated fade"><p>' . L_IEME_MESSAGE_CACHE_CLEARED . '</p></div>';
  }

  // settings
  $ieme_rx_theme = get_option('ieme_rx_theme');
  // theme dependent settings
  $ieme_rx_width = get_option('ieme_rx_width[' . $ieme_rx_theme . ']');
  $ieme_rx_height = get_option('ieme_rx_height[' . $ieme_rx_theme . ']');
  $ieme_rx_background = get_option('ieme_rx_background[' . $ieme_rx_theme . ']');
  $ieme_rx_fontfamily = get_option('ieme_rx_fontfamily[' . $ieme_rx_theme . ']');
  $ieme_rx_fontsize = get_option('ieme_rx_fontsize[' . $ieme_rx_theme . ']');
  $ieme_rx_description_length = get_option('ieme_rx_description_length[' . $ieme_rx_theme . ']');
  // theme independent settings
  $ieme_rx_language = get_option('ieme_rx_language');
  $ieme_rx_source = get_option('ieme_rx_source');

?>
<div class="wrap">
<h2><?php print L_IEME_OPTIONS_TITLE; ?></h2>

<form method="post" enctype="multipart/form-data" id="ieme_options_form">

<table class="optiontable">

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_THEME; ?></label></th>
  <td><select name="rx_theme" id="rx_theme" class="text" onchange="document.getElementById('rx_submit').click();"><?php
    $rx_themes = array(
      'simple' => 'simple',
      'advanced-description' => 'advanced (with plot description)',
      'advanced' => 'advanced (without plot description)',
      'vertical' => 'vertical',
      'mini' => 'mini',
    );
    foreach ($rx_themes as $theme_index => $theme)
    {
      print '<option value="' . $theme_index . '"' . ((0 == strcasecmp($ieme_rx_theme, $theme_index))? ' selected="selected"' : '') . '>' . $theme . '</option>';
    }
  ?></select></td>
</tr>

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_WIDTH; ?></label></th>
  <td><input type="text" name="rx_width" id="rx_width" class="text" size="6" value="<?php print stripslashes($ieme_rx_width); ?>" /></td>
</tr>

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_HEIGHT; ?></label></th>
  <td><input type="text" name="rx_height" id="rx_height" class="text" size="6" value="<?php print stripslashes($ieme_rx_height); ?>" /></td>
</tr>

<!--
<tr valign="top">
  <th scope="row"><label><?php print L_IEME_LANGUAGE; ?></label></th>
  <td><select name="rx_language" id="rx_language" class="text"><?php
    $rx_languages = array('romana', 'english', 'magyar');
    foreach ($rx_languages as $language)
    {
      print '<option value="' . $language . '"' . ((0 == strcasecmp($ieme_rx_language, $language))? ' selected="selected"' : '') . '>' . $language . '</option>';
    }
  ?></select></td>
</tr>
-->
<!--
<tr valign="top">
  <th scope="row"><label><?php print L_IEME_SOURCE; ?></label></th>
  <td><select name="rx_source" id="rx_source" class="text"><?php
    $rx_sources = array('CinemaRx', 'IMDb');
    foreach ($rx_sources as $source)
    {
      print '<option value="' . $source . '"' . ((0 == strcasecmp($ieme_rx_source, $source))? ' selected="selected"' : '') . '>' . $source . '</option>';
    }
  ?></select></td>
</tr>
-->

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_BACKGROUND; ?></label></th>
  <td><input type="text" name="rx_background" id="rx_background" class="text" size="30" value="<?php print stripslashes($ieme_rx_background); ?>" /></td>
</tr>

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_FONT_FAMILY; ?></label></th>
  <td><input type="text" name="rx_fontfamily" id="rx_fontfamily" class="text" size="30" value="<?php print stripslashes($ieme_rx_fontfamily); ?>" /></td>
</tr>

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_FONT_SIZE; ?></label></th>
  <td><input type="text" name="rx_fontsize" id="rx_fontsize" class="text" size="30" value="<?php print stripslashes($ieme_rx_fontsize); ?>" /></td>
</tr>

<tr valign="top">
  <th scope="row"><label><?php print L_IEME_DESCRIPTION_LENGTH; ?></label></th>
  <td><input type="text" name="rx_description_length" id="rx_description_length" class="text" size="6" value="<?php print stripslashes($ieme_rx_description_length); ?>" /></td>
</tr>

</table>

<p class="submit"><input type="submit" id="rx_submit" name="rx_submit" value="<?php print L_IEME_UPDATE_BTN; ?>" /></p>
<p class="submit"><input type="submit" id="rx_resetcache" name="rx_resetcache" value="<?php print L_IEME_RESETCACHE_BTN; ?>" /></p>

<p><?php print L_IEME_INFO; ?></p>

</form>

</div>

<?php
}

# Add 'IEME' page to Wordpress' Options menu
function wp_ieme_add_options_page() {
    if (function_exists('add_options_page')) {
		  add_options_page('IEME_Options', 'IEME Options', 8, basename(__FILE__), 'wp_ieme_options_page');
    }
}

# Add actions for admin panel
add_action('admin_menu', 'wp_ieme_add_options_page');

# Add to header
add_action('wp_head', 'wp_ieme_wp_head');


?>
